#ifndef __DREUTILS_H__
#define __DREUTILS_H__

// The standard normal distribution
double ndist(double z, bool upper);

// Inverse normal distribution
double ninv(double p);

// Solve equation of the type f(x) = target
double solve (double (*func)(double, void * extras), void * extras,
              double target, double lo, double hi, double e);

// Adaptive numerical integration
double update_integral(double (*f)(double x, void * extras), void * extras,
                       double a, double b, double previous, int round);
double integral(double (*f)(double x, void * extras), void * extras,
                double a, double b, double eps, int minrounds = 5);

// Be Square!
double square(double x);

// Formulas for joint analysis power calculation
double pjoint(double cjoint, void * parameters);
double stuff_to_integrate(double z1, void * parameters);

#endif

